# generated by datamodel-codegen:
#   filename:  entity/services/connections/dashboard/powerBIConnection.json
#   timestamp: 2024-05-02T07:41:57+00:00

from __future__ import annotations

from enum import Enum
from typing import List, Optional, Union

from pydantic import AnyUrl, BaseModel, Extra, Field

from metadata.ingestion.models.custom_pydantic import CustomSecretStr

from .. import connectionBasicType
from .powerbi import azureConfig, gcsConfig, s3Config


class PowerBiType(Enum):
    PowerBI = 'PowerBI'


class PbitFileConfigType(Enum):
    local = 'local'


class LocalConfig(BaseModel):
    class Config:
        extra = Extra.forbid

    pbitFileConfigType: Optional[PbitFileConfigType] = Field(
        PbitFileConfigType.local, description='pbit File Configuration type'
    )
    path: Optional[str] = Field(
        None, description='Directory path for the pbit files', title='Path'
    )
    pbitFilesExtractDir: Optional[str] = Field(
        '/tmp/pbitFiles',
        description='Path of the folder where the .pbit files will be unzipped and datamodel schema will be extracted',
        title='pbit Files Extraction Directory',
    )


class PowerBIConnection(BaseModel):
    class Config:
        extra = Extra.forbid

    type: Optional[PowerBiType] = Field(
        PowerBiType.PowerBI, description='Service Type', title='Service Type'
    )
    clientId: str = Field(..., description='client_id for PowerBI.', title='Client ID')
    clientSecret: CustomSecretStr = Field(
        ..., description='clientSecret for PowerBI.', title='Client Secret'
    )
    tenantId: str = Field(..., description='Tenant ID for PowerBI.', title='Tenant ID')
    authorityURI: Optional[str] = Field(
        'https://login.microsoftonline.com/',
        description='Authority URI for the PowerBI service.',
        title='Authority URI',
    )
    hostPort: Optional[AnyUrl] = Field(
        'https://app.powerbi.com',
        description='Dashboard URL for PowerBI service.',
        title='Host and Port',
    )
    scope: Optional[List[str]] = Field(
        ['https://analysis.windows.net/powerbi/api/.default'],
        description='PowerBI secrets.',
        title='Scope',
    )
    pagination_entity_per_page: Optional[int] = Field(
        100,
        description='Entity Limit set here will be used to paginate the PowerBi APIs',
        title='Pagination Entity Per Page',
    )
    useAdminApis: Optional[bool] = Field(
        True,
        description='Fetch the PowerBI metadata using admin APIs',
        title='Use PowerBI Admin APIs',
    )
    pbitFilesSource: Optional[
        Union[
            LocalConfig, azureConfig.AzureConfig, gcsConfig.GCSConfig, s3Config.S3Config
        ]
    ] = Field(
        None,
        description='Source to get the .pbit files to extract lineage information',
        title='PowerBI .pbit Files Source',
    )
    supportsMetadataExtraction: Optional[
        connectionBasicType.SupportsMetadataExtraction
    ] = Field(None, title='Supports Metadata Extraction')
