# generated by datamodel-codegen:
#   filename:  metadataIngestion/dbtconfig/dbtGCSConfig.json
#   timestamp: 2024-05-02T07:41:57+00:00

from __future__ import annotations

from enum import Enum
from typing import Optional

from pydantic import BaseModel, Extra, Field

from ...security.credentials import gcpCredentials


class DbtConfigType(Enum):
    gcs = 'gcs'


class DbtPrefixConfig(BaseModel):
    class Config:
        extra = Extra.forbid

    dbtBucketName: Optional[str] = Field(
        None,
        description='Name of the bucket where the dbt files are stored',
        title='DBT Bucket Name',
    )
    dbtObjectPrefix: Optional[str] = Field(
        None,
        description='Path of the folder where the dbt files are stored',
        title='DBT Object Prefix',
    )


class DbtGcsConfig(BaseModel):
    class Config:
        extra = Extra.forbid

    dbtConfigType: DbtConfigType = Field(..., description='dbt Configuration type')
    dbtSecurityConfig: gcpCredentials.GCPCredentials = Field(
        ..., title='DBT GCS Security Config'
    )
    dbtPrefixConfig: Optional[DbtPrefixConfig] = Field(
        None,
        description='Details of the bucket where the dbt files are stored',
        title='DBT Prefix Config',
    )
