# generated by datamodel-codegen:
#   filename:  security/credentials/azureCredentials.json
#   timestamp: 2024-05-02T07:41:57+00:00

from __future__ import annotations

from typing import Optional

from pydantic import BaseModel, Extra, Field

from metadata.ingestion.models.custom_pydantic import CustomSecretStr


class AzureCredentials(BaseModel):
    class Config:
        extra = Extra.forbid

    clientId: Optional[str] = Field(
        None, description='Your Service Principal App ID (Client ID)', title='Client ID'
    )
    clientSecret: Optional[CustomSecretStr] = Field(
        None,
        description='Your Service Principal Password (Client Secret)',
        title='Client Secret',
    )
    tenantId: Optional[str] = Field(
        None, description='Tenant ID of your Azure Subscription', title='Tenant ID'
    )
    accountName: Optional[str] = Field(
        None,
        description='Account Name of your storage account',
        title='Storage Account Name',
    )
    vaultName: Optional[str] = Field(
        None, description='Key Vault Name', title='Key Vault Name'
    )
    scopes: Optional[str] = Field(
        None,
        description='Scopes to get access token, for e.g. api://6dfX33ab-XXXX-49df-XXXX-3459eX817d3e/.default',
        title='Scopes',
    )
