# generated by datamodel-codegen:
#   filename:  system/validationResponse.json
#   timestamp: 2024-05-02T07:41:57+00:00

from __future__ import annotations

from typing import Optional

from pydantic import BaseModel, Extra, Field


class StepValidation(BaseModel):
    class Config:
        extra = Extra.forbid

    description: Optional[str] = Field(
        None, description='Validation description. What is being tested?'
    )
    passed: Optional[bool] = Field(
        None, description='Did the step validation successfully?'
    )
    message: Optional[str] = Field(
        None, description='Results or exceptions to be shared after running the test.'
    )


class SystemValidationResponse(BaseModel):
    class Config:
        extra = Extra.forbid

    database: Optional[StepValidation] = Field(
        None, description='Database connectivity check'
    )
    searchInstance: Optional[StepValidation] = Field(
        None, description='Search instance connectivity check'
    )
    pipelineServiceClient: Optional[StepValidation] = Field(
        None, description='Pipeline Service Client connectivity check'
    )
    jwks: Optional[StepValidation] = Field(None, description='JWKs validation')
    migrations: Optional[StepValidation] = Field(
        None, description='List migration results'
    )
