# generated by datamodel-codegen:
#   filename:  tests/testCaseResolutionStatus.json
#   timestamp: 2024-05-02T07:41:57+00:00

from __future__ import annotations

from enum import Enum
from typing import Optional, Union

from pydantic import BaseModel, Extra, Field

from ..type import basic, entityReference
from . import assigned, resolved


class TestCaseResolutionStatusTypes(Enum):
    New = 'New'
    Ack = 'Ack'
    Assigned = 'Assigned'
    Resolved = 'Resolved'


class Severities(Enum):
    Severity1 = 'Severity1'
    Severity2 = 'Severity2'
    Severity3 = 'Severity3'
    Severity4 = 'Severity4'
    Severity5 = 'Severity5'


class TestCaseResolutionStatus(BaseModel):
    class Config:
        extra = Extra.forbid

    id: Optional[basic.Uuid] = Field(
        None, description='Unique identifier of this failure instance'
    )
    stateId: Optional[basic.Uuid] = Field(
        None,
        description='Sequence ID for a failure status. Statuses belonging to the same sequence will have the same ID. Unique across a failure cycle, i.e. new -> ack -> ... -> resolved.',
    )
    timestamp: Optional[basic.Timestamp] = Field(
        None, description='Timestamp on which the failure was created.'
    )
    testCaseResolutionStatusType: TestCaseResolutionStatusTypes = Field(
        ..., description='Status of Test Case Acknowledgement.'
    )
    testCaseResolutionStatusDetails: Optional[
        Union[assigned.Assigned, resolved.Resolved]
    ] = Field(None, description='Details of the test case failure status.')
    updatedBy: Optional[entityReference.EntityReference] = Field(
        None, description='User who updated the test case failure status.'
    )
    updatedAt: Optional[basic.Timestamp] = Field(
        None, description='Time when test case resolution was updated.'
    )
    testCaseReference: Optional[entityReference.EntityReference] = Field(
        None, description='Test case reference'
    )
    severity: Optional[Severities] = Field(
        None,
        description='Severity failure for the test associated with the resolution.',
    )
